-- Open, Add Charcoal, Fire, Pin, and arrange your forge windows
-- **Does not take items**
-- ***********************
-- Times:
-- 1 Minute = 72*1000
-- 2 Minutes = 144*1000
-- 3 Minutes = 216*1000
-- 5 Minutes = 360*1000
-- 6 Minutes = 432*1000
-- 10 Minutes = 720*1000
-- 20 minutes = 1440*1000
-- ***********************


loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();

local per_click_delay = 0;

function setWaitSpot(x0, y0)
	setWaitSpot_x = x0;
	setWaitSpot_y = y0;
	setWaitSpot_px = srReadPixel(x0, y0);
end

function waitForChange()
	local c=0;
	while srReadPixel(setWaitSpot_x, setWaitSpot_y) == setWaitSpot_px do
		lsSleep(1);
		c = c+1;
		if (lsShiftHeld() and lsControlHeld()) then
			error 'broke out of loop from Shift+Ctrl';
		end
	end
	-- lsPrintln('Waited ' .. c .. 'ms for pixel to change.');
end

function clickAll(image_name, up, image_name2)
	-- Find buttons and click them!
	srReadScreen();
	xyWindowSize = srGetWindowSize();
	local buttons = findAllImages(image_name);
	
	if #buttons == 0 and image_name2 then
		buttons = findAllImages(image_name2);
	end
	
	if #buttons == 0 then
		statusScreen("Could not find specified buttons...");
		lsSleep(1500);
	else
		statusScreen("Clicking " .. #buttons .. "button(s)...");
		if up then
			for i=#buttons, 1, -1  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		end
		statusScreen("Done clicking (" .. #buttons .. " clicks).");
		lsSleep(100);
	end
end

function refocus()
	statusScreen("Refocusing...");
	for i=2, #window_locs do
		setWaitSpot(window_locs[i][0], window_locs[i][1]);
		srClickMouseNoMove(window_locs[i][0] + 321, window_locs[i][1] + 74);
		waitForChange();
	end
end

-- Begin Forge functions

function LeadSheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Lead_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*10000, "[" .. i .. "/" .. num_loops .. "] Waiting for Lead Sheeting to finish");
	end
end

function GoldSheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Gold_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*10000, "[" .. i .. "/" .. num_loops .. "] Waiting for Gold Sheeting to finish");
	end
end

function CopperSheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Copper_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*1000, "[" .. i .. "/" .. num_loops .. "] Waiting for Copper Sheeting to finish");
	end
end

function OctecsAlloySheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Octecs_Alloy_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*20000, "[" .. i .. "/" .. num_loops .. "] Waiting for Octecs Alloy Sheeting to finish");
	end
end

function SilverSheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png");
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Silver_Sheeting.png");
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*2000, "[" .. i .. "/" .. num_loops .. "] Waiting for Silver Sheeting to finish");
	end
end

function SteelSheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png");
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Steel_Sheeting.png");
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*10000, "[" .. i .. "/" .. num_loops .. "] Waiting for Steel Sheeting to finish");
	end
end

function GoldFoil()

	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
		
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Gold_Foil.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*1000, "[" .. i .. "/" .. num_loops .. "] Waiting for Gold Foil to finish");
	end
end

function MetalBlueSheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png");
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Metal_Blue_Sheeting.png");
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*15000, "[" .. i .. "/" .. num_loops .. "] Waiting for Metal Blue Sheeting to finish");
	end
end

function TinSheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png");
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Tin_Sheeting.png");
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*5000, "[" .. i .. "/" .. num_loops .. "] Waiting for Tin Sheeting to finish");
	end
end

function MoonSteelSheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png");
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Moon_Steel_Sheeting.png");
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*5000, "[" .. i .. "/" .. num_loops .. "] Waiting for Moon Steel Sheeting to finish");
	end
end

function ThothsMetalSheeting()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png");
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Sheeting.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Thoths_Metal_Sheeting.png");
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*10000, "[" .. i .. "/" .. num_loops .. "] Waiting for Thoths Metal Sheeting to finish");
	end
end


button_names = {
"Lead Sheeting",
"Gold Sheeting",
"Copper Sheeting",
"Octecs Alloy Sheeting",
"Silver Sheeting",
"Steel Sheeting",
"Gold Foil",
"Metal Blue Sheeting",
"Tin Sheeting",
"Moon Steel Sheeting",
"Thoths Metal Sheeting"
};

function doit()
	while 1 do
		-- Ask for which button
		local image_name = nil;
		local is_done = nil;	
		while not is_done do
			local y = nil;
			local x = nil;
			local bsize = nil;
			for i=1, #button_names do
				if button_names[i] == "Lead Sheeting" then
					x = 30;
					y = 10;
					bsize = 150;
				elseif button_names[i] == "Gold Sheeting" then
					x = 30;
					y = 35;
					bsize = 150;
				elseif button_names[i] == "Copper Sheeting" then
					x = 30;
					y = 60;
					bsize = 150;
				elseif button_names[i] == "Octecs Alloy Sheeting" then
					x = 30;
					y = 85;
					bsize = 150;
				elseif button_names[i] == "Silver Sheeting" then
					x = 30;
					y = 110;
					bsize = 150;
				elseif button_names[i] == "Steel Sheeting" then
					x = 30;
					y = 135;
					bsize = 150;
				elseif button_names[i] == "Gold Foil" then
					x = 30;
					y = 160;
					bsize = 150;
				elseif button_names[i] == "Metal Blue Sheeting" then
					x = 30;
					y = 185;
					bsize = 150;
				elseif button_names[i] == "Tin Sheeting" then
					x = 30;
					y = 210;
					bsize = 150;
				elseif button_names[i] == "Moon Steel Sheeting" then
					x = 30;
					y = 235;
					bsize = 150;
				elseif button_names[i] == "Thoths Metal Sheeting" then
					x = 30;
					y = 260;
					bsize = 150;
				end
				if lsButtonText(x, y, 0, 250, 0x80D080ff, button_names[i]) then
					image_name = button_names[i];
					is_done = 1;
				end
			end

			if lsButtonText(lsScreenX - 110, lsScreenY - 30, z, 100, 0xFFFFFFff, "End script") then
				error "Clicked End Script button";
			end
			lsDoFrame();
			lsSleep(10);
		end	
		
		if image_name == "Lead Sheeting" then
			LeadSheeting();
		elseif image_name == "Gold Sheeting" then
			GoldSheeting();
		elseif image_name == "Copper Sheeting" then
			CopperSheeting();
		elseif image_name == "Octecs Alloy Sheeting" then
			OctecsAlloySheeting();
		elseif image_name == "Silver Sheeting" then
			SilverSheeting();
		elseif image_name == "Steel Sheeting" then
			SteelSheeting();
		elseif image_name == "Gold Foil" then
			GoldFoil();
		elseif image_name == "Metal Blue Sheeting" then
			MetalBlueSheeting();
		elseif image_name == "Tin Sheeting" then
			TinSheeting();
		elseif image_name == "Moon Steel Sheeting" then
			MoonSteelSheeting();
		elseif image_name == "Thoths Metal Sheeting" then
			ThothsMetalSheeting();
		end
	end
end
