-- Open, Add Charcoal, Fire, Pin, and arrange your forge windows
-- **Does not take items**
-- ***********************
-- Times:
-- 1 Minute = 72*1000
-- 2 Minutes = 144*1000
-- 3 Minutes = 216*1000
-- 5 Minutes = 360*1000
-- 6 Minutes = 432*1000
-- 10 Minutes = 720*1000
-- 20 minutes = 1440*1000
-- ***********************


loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();

local per_click_delay = 0;

function setWaitSpot(x0, y0)
	setWaitSpot_x = x0;
	setWaitSpot_y = y0;
	setWaitSpot_px = srReadPixel(x0, y0);
end

function waitForChange()
	local c=0;
	while srReadPixel(setWaitSpot_x, setWaitSpot_y) == setWaitSpot_px do
		lsSleep(1);
		c = c+1;
		if (lsShiftHeld() and lsControlHeld()) then
			error 'broke out of loop from Shift+Ctrl';
		end
	end
	-- lsPrintln('Waited ' .. c .. 'ms for pixel to change.');
end

function clickAll(image_name, up, image_name2)
	-- Find buttons and click them!
	srReadScreen();
	xyWindowSize = srGetWindowSize();
	local buttons = findAllImages(image_name);
	
	if #buttons == 0 and image_name2 then
		buttons = findAllImages(image_name2);
	end
	
	if #buttons == 0 then
		statusScreen("Could not find specified buttons...");
		lsSleep(1500);
	else
		statusScreen("Clicking " .. #buttons .. "button(s)...");
		if up then
			for i=#buttons, 1, -1  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		end
		statusScreen("Done clicking (" .. #buttons .. " clicks).");
		lsSleep(100);
	end
end

function refocus()
	statusScreen("Refocusing...");
	for i=2, #window_locs do
		setWaitSpot(window_locs[i][0], window_locs[i][1]);
		srClickMouseNoMove(window_locs[i][0] + 321, window_locs[i][1] + 74);
		waitForChange();
	end
end

-- Begin Forge functions

	function IronPoker()

	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

		for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
				
		-- refresh windows
		clickAll("Forge_Tools.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Iron_Poker.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*20000, "[" .. i .. "/" .. num_loops .. "] Waiting for Iron Pokers to finish");
		end
	end

	function SteelBlade()

	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

		for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
				
		-- refresh windows
		clickAll("Forge_Tools.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Steel_Blade.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*10000, "[" .. i .. "/" .. num_loops .. "] Waiting for Steel Blades to finish");
		end
	end
	
	function LeadChisel()

	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

		for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
				
		-- refresh windows
		clickAll("Forge_Bars.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Lead_Chisel.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*6000, "[" .. i .. "/" .. num_loops .. "] Waiting for Lead Chisels to finish");
		end
	end

button_names = {
"Iron Poker",
"Steel Blade",
"Lead Chisel"
};


function doit()
	while 1 do
		-- Ask for which button
		local image_name = nil;
		local is_done = nil;	
		while not is_done do
			local y = nil;
			local x = nil;
			local bsize = nil;
			for i=1, #button_names do
				if button_names[i] == "Iron Poker" then
					x = 30;
					y = 10;
					bsize = 250;
				elseif button_names[i] == "Steel Blade" then
					x = 30;
					y = 40;
					bsize = 250;
				elseif button_names[i] == "Lead Chisel" then
					x = 30;
					y = 70;
					bsize = 250;
				end
				if lsButtonText(x, y, 0, bsize, 0x80D080ff, button_names[i]) then
					image_name = button_names[i];
					is_done = 1;
				end
			end

			if lsButtonText(lsScreenX - 110, lsScreenY - 30, z, 100, 0xFFFFFFff, "End script") then
				error "Clicked End Script button";
			end
			lsDoFrame();
			lsSleep(10);
		end	
		
		if image_name == "Iron Poker" then
			IronPoker();
		elseif image_name == "Steel Blade" then
			SteelBlade();
		elseif image_name == "Lead Chisel" then
			LeadChisel();
		end
	end
end
