-- Open, Add Charcoal, Fire, Pin, and arrange your forge windows
-- **Does not take items**
-- ***********************
-- Times:
-- 1 Minute = 72*1000
-- 2 Minutes = 144*1000
-- 3 Minutes = 216*1000
-- 5 Minutes = 360*1000
-- 6 Minutes = 432*1000
-- 10 Minutes = 720*1000
-- 20 minutes = 1440*1000
-- ***********************


loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();

local per_click_delay = 0;

function setWaitSpot(x0, y0)
	setWaitSpot_x = x0;
	setWaitSpot_y = y0;
	setWaitSpot_px = srReadPixel(x0, y0);
end

function waitForChange()
	local c=0;
	while srReadPixel(setWaitSpot_x, setWaitSpot_y) == setWaitSpot_px do
		lsSleep(1);
		c = c+1;
		if (lsShiftHeld() and lsControlHeld()) then
			error 'broke out of loop from Shift+Ctrl';
		end
	end
	-- lsPrintln('Waited ' .. c .. 'ms for pixel to change.');
end

function clickAll(image_name, up, image_name2)
	-- Find buttons and click them!
	srReadScreen();
	xyWindowSize = srGetWindowSize();
	local buttons = findAllImages(image_name);
	
	if #buttons == 0 and image_name2 then
		buttons = findAllImages(image_name2);
	end
	
	if #buttons == 0 then
		statusScreen("Could not find specified buttons...");
		lsSleep(1500);
	else
		statusScreen("Clicking " .. #buttons .. "button(s)...");
		if up then
			for i=#buttons, 1, -1  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		end
		statusScreen("Done clicking (" .. #buttons .. " clicks).");
		lsSleep(100);
	end
end

function refocus()
	statusScreen("Refocusing...");
	for i=2, #window_locs do
		setWaitSpot(window_locs[i][0], window_locs[i][1]);
		srClickMouseNoMove(window_locs[i][0] + 321, window_locs[i][1] + 74);
		waitForChange();
	end
end

-- Begin Forge functions

function ThothsMetalWire()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Thoths_Metal_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*5000, "[" .. i .. "/" .. num_loops .. "] Waiting for Thoths Metal Wire to finish");
	end
end

function MetalBlueWire()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Metal_Blue_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*5000, "[" .. i .. "/" .. num_loops .. "] Waiting for Metal Blue Wire to finish");
	end
end

function MagnesiumWire()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Magnesium_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*1000, "[" .. i .. "/" .. num_loops .. "] Waiting for Magnesium Wire to finish");
	end
end

function OctecsAlloyWire()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Octecs_Alloy_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*5000, "[" .. i .. "/" .. num_loops .. "] Waiting for Octecs Alloy Wire to finish");
	end
end

function SilverWire()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Silver_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*5000, "[" .. i .. "/" .. num_loops .. "] Waiting for Silver Wire to finish");
	end
end

function CopperWire()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Copper_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*5000, "[" .. i .. "/" .. num_loops .. "] Waiting for Copper Wire to finish");
	end
end

function SteelWire()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Steel_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*5000, "[" .. i .. "/" .. num_loops .. "] Waiting for Steel Wire to finish");
	end
end

function GoldWire()
	num_loops = promptNumber("How many passes ?", 100);
	askForWindow("Fill forges with charcoal, arrange, and fire the forges first before you pin the menu.");
	
	srReadScreen();

	local buttons = findAllImages(image_name);
	for i=1, num_loops do
		window_locs = findAllImages("This.png");

		-- refresh windows
		clickAll("This.png", 1);
		lsSleep(200);
		-- refocus();
			
		-- refresh windows
		clickAll("Forge_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		clickAll("Forge_Gold_Wire.png", 1);
		lsSleep(200);
		-- refocus();
		
		sleepWithStatus(72*10000, "[" .. i .. "/" .. num_loops .. "] Waiting for Gold Wire to finish");
	end
end

button_names = {
"Thoths Metal Wire",
"Metal Blue Wire",
"Magnesium Wire",
"Octecs Alloy Wire",
"Silver Wire",
"Copper Wire",
"Steel Wire",
"Gold Wire"
};

function doit()
	while 1 do
		-- Ask for which button
		local image_name = nil;
		local is_done = nil;	
		while not is_done do
			local y = nil;
			local x = nil;
			local bsize = nil;
			for i=1, #button_names do
				if button_names[i] == "Thoths Metal Wire" then
					x = 30;
					y = 10;
					bsize = 150;
				elseif button_names[i] == "Metal Blue Wire" then
					x = 30;
					y = 35;
					bsize = 150;
				elseif button_names[i] == "Magnesium Wire" then
					x = 30;
					y = 60;
					bsize = 150;
				elseif button_names[i] == "Octecs Alloy Wire" then
					x = 30;
					y = 85;
					bsize = 150;
				elseif button_names[i] == "Silver Wire" then
					x = 30;
					y = 110;
					bsize = 150;
				elseif button_names[i] == "Copper Wire" then
					x = 30;
					y = 135;
					bsize = 150;
				elseif button_names[i] == "Steel Wire" then
					x = 30;
					y = 160;
					bsize = 150;
				elseif button_names[i] == "Gold Wire" then
					x = 30;
					y = 185;
					bsize = 150;
				end
				if lsButtonText(x, y, 0, 250, 0x80D080ff, button_names[i]) then
					image_name = button_names[i];
					is_done = 1;
				end
			end

			if lsButtonText(lsScreenX - 110, lsScreenY - 30, z, 100, 0xFFFFFFff, "End script") then
				error "Clicked End Script button";
			end
			lsDoFrame();
			lsSleep(10);
		end	
		
		if image_name == "Thoths Metal Wire" then
			ThothsMetalWire();
		elseif image_name == "Metal Blue Wire" then
			MetalBlueWire();
		elseif image_name == "Magnesium Wire" then
			MagnesiumWire();
		elseif image_name == "Octecs Alloy Wire" then
			OctecsAlloyWire();
		elseif image_name == "Silver Wire" then
			SilverWire();
		elseif image_name == "Copper Wire" then
			CopperWire();
		elseif image_name == "Steel Wire" then
			SteelWire();
		elseif image_name == "Gold Wire" then
			GoldWire();
		end
	end
end
